=== modified file 'lib/canonical/launchpad/components/externalbugtracker/trac.py'
--- lib/canonical/launchpad/components/externalbugtracker/trac.py	2008-05-13 08:51:39 +0000
+++ lib/canonical/launchpad/components/externalbugtracker/trac.py	2008-05-22 11:58:08 +0000
@@ -24,6 +24,7 @@
     BugTaskStatus, BugTaskImportance, IMessageSet,
     ISupportsCommentImport, ISupportsCommentPushing,
     UNKNOWN_REMOTE_IMPORTANCE)
+from canonical.launchpad.validators.email import valid_email
 from canonical.launchpad.webapp.url import urlappend
 
 
@@ -398,12 +399,12 @@
 
         display_name, email = parseaddr(comment['user'])
 
-        # If the name is empty then we return None so that
-        # IPersonSet.ensurePerson() can actually do something with it.
-        if not display_name:
-            display_name = None
-
-        return (display_name, email)
+        if not valid_email(email):
+            return email, None
+        elif display_name == '':
+            return None, email
+        else:
+            return display_name, email
 
     def getMessageForComment(self, bug_watch, comment_id, poster):
         """See `ISupportsCommentImport`."""

=== modified file 'lib/canonical/launchpad/doc/externalbugtracker-trac-lp-plugin.txt'
--- lib/canonical/launchpad/doc/externalbugtracker-trac-lp-plugin.txt	2008-05-13 09:07:29 +0000
+++ lib/canonical/launchpad/doc/externalbugtracker-trac-lp-plugin.txt	2008-05-22 11:58:08 +0000
@@ -399,13 +399,11 @@
 
 getPosterForComment() will also return displayname, email tuples in
 cases where the 'user' field is set to a plain username (e.g. 'foo').
-This is to avoid having to add unnecessary error checking to
-BugWatchUpdater.importBugComments(), however, when the contents of the
-tuple are passed to ensurePerson() an InvalidEmailAddress error will be
-raised, thus avoiding invalid data being imported into Launchpad.
+However, in these cases it is the email address that will be set to
+None.
 
     >>> trac.getPosterForComment(bug_watch_two, '2-2')
-    (None, 'foo.bar')
+    ('foo.bar', None)
 
 Finally, getMessageForComment() will return a Message instance for a
 given comment. For the sake of brevity we'll use test@canonical.com as

